<?php
/**
 * @package Demo Import
 * @since 1.0.0
 */

class ThemeWhizzie {

	protected $version = '1.1.0';

	/** @var string Current theme name, used as namespace in actions. */
	protected $theme_name = '';
	protected $theme_title = '';

	/** @var string Demo Import page slug and title. */
	protected $page_slug = '';
	protected $page_title = '';

	/** @var array Demo Import steps set by user. */
	protected $config_steps = array();

	/**
	 * Relative plugin url for this plugin folder
	 * @since 1.0.0
	 * @var string
	*/
	protected $plugin_url = '';
	protected $plugin_path = '';
	public $parent_slug;
	/**
	 * TGMPA instance storage
	 *
	 * @var object
	*/
	protected $tgmpa_instance;

	/**
	 * TGMPA Menu slug
	 *
	 * @var string
	*/
	protected $tgmpa_menu_slug = 'tgmpa-install-plugins';

	/**
	 * TGMPA Menu url
	 *
	 * @var string
	*/
	protected $tgmpa_url = 'themes.php?page=tgmpa-install-plugins';
	/**
	 * Constructor
	 *
	 * @param $massage_wellness_retreat_config	Our config parameters
	*/
	public function __construct( $massage_wellness_retreat_config ) {
		$this->set_vars( $massage_wellness_retreat_config );
		$this->init();

		include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
	}

	/**
	 * Set some settings
	 * @since 1.0.0
	 * @param $massage_wellness_retreat_config	Our config parameters
	*/
	public function set_vars( $massage_wellness_retreat_config ) {

		require_once trailingslashit( WHIZZIE_DIR ) . 'tgm/tgm.php';

		if( isset( $massage_wellness_retreat_config['page_slug'] ) ) {
			$this->page_slug = esc_attr( $massage_wellness_retreat_config['page_slug'] );
		}
		if( isset( $massage_wellness_retreat_config['page_title'] ) ) {
			$this->page_title = esc_attr( $massage_wellness_retreat_config['page_title'] );
		}
		if( isset( $massage_wellness_retreat_config['steps'] ) ) {
			$this->config_steps = $massage_wellness_retreat_config['steps'];
		}

		$this->plugin_path = trailingslashit( dirname( __FILE__ ) );
		$relative_url = str_replace( get_template_directory(), '', $this->plugin_path );
		$this->plugin_url = trailingslashit( get_template_directory_uri() . $relative_url );
		$current_theme = wp_get_theme();
		$this->theme_title = $current_theme->get( 'Name' );
		$this->theme_name = strtolower( preg_replace( '#[^a-zA-Z]#', '', $current_theme->get( 'Name' ) ) );
		$this->page_slug = apply_filters( $this->theme_name . '_theme_setup_wizard_page_slug', $this->theme_name . '-demoimport' );
		$this->parent_slug = apply_filters( $this->theme_name . '_theme_setup_wizard_parent_slug', '' );
	}

	/**
	 * Hooks and filters
	 * @since 1.0.0
	*/
	public function init() {

		if ( class_exists( 'TGM_Plugin_Activation' ) && isset( $GLOBALS['tgmpa'] ) ) {
			add_action( 'init', array( $this, 'get_tgmpa_instance' ), 30 );
			add_action( 'init', array( $this, 'set_tgmpa_url' ), 40 );
		}

		add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );
		add_action( 'admin_menu', array( $this, 'menu_page' ) );
		add_action( 'admin_init', array( $this, 'get_plugins' ), 30 );
		add_filter( 'tgmpa_load', array( $this, 'tgmpa_load' ), 10, 1 );
		add_action( 'wp_ajax_setup_plugins', array( $this, 'setup_plugins' ) );
		add_action( 'wp_ajax_setup_widgets', array( $this, 'setup_widgets' ) );
	}

	public function enqueue_scripts() {
		wp_enqueue_style( 'demo-import-style', get_template_directory_uri() . '/demo-import/assets/css/demo-import-style.css');
		wp_register_script( 'demo-import-script', get_template_directory_uri() . '/demo-import/assets/js/demo-import-script.js', array( 'jquery' ), time() );
		wp_localize_script(
			'demo-import-script',
			'massage_wellness_retreat_whizzie_params',
			array(
				'ajaxurl' 		=> admin_url( 'admin-ajax.php' ),
				'wpnonce' 		=> wp_create_nonce( 'whizzie_nonce' ),
				'verify_text'	=> esc_html( 'verifying', 'massage-wellness-retreat' )
			)
		);
		wp_enqueue_script( 'demo-import-script' );
	}

	public function tgmpa_load( $status ) {
		return is_admin() || current_user_can( 'install_themes' );
	}

	/**
	 * Get configured TGMPA instance
	 *
	 * @access public
	 * @since 1.1.2
	*/
	public function get_tgmpa_instance() {
		$this->tgmpa_instance = call_user_func( array( get_class( $GLOBALS['tgmpa'] ), 'get_instance' ) );
	}

	/**
	 * Update $tgmpa_menu_slug and $tgmpa_parent_slug from TGMPA instance
	 *
	 * @access public
	 * @since 1.1.2
	*/
	public function set_tgmpa_url() {
		$this->tgmpa_menu_slug = ( property_exists( $this->tgmpa_instance, 'menu' ) ) ? $this->tgmpa_instance->menu : $this->tgmpa_menu_slug;
		$this->tgmpa_menu_slug = apply_filters( $this->theme_name . '_theme_setup_wizard_tgmpa_menu_slug', $this->tgmpa_menu_slug );
		$tgmpa_parent_slug = ( property_exists( $this->tgmpa_instance, 'parent_slug' ) && $this->tgmpa_instance->parent_slug !== 'themes.php' ) ? 'admin.php' : 'themes.php';
		$this->tgmpa_url = apply_filters( $this->theme_name . '_theme_setup_wizard_tgmpa_url', $tgmpa_parent_slug . '?page=' . $this->tgmpa_menu_slug );
	}


	/**  Make a modal screen for the wizard **/
	public function menu_page() {
		add_menu_page( esc_html( $this->page_title ), esc_html( $this->page_title ), 'manage_options', $this->page_slug, array( $this, 'massage_wellness_retreat_guide' ) ,'',40);
	}

	/*** Make an interface for the wizard ***/
	public function wizard_page() {

		tgmpa_load_bulk_installer();

		// install plugins with TGM.
		if ( ! class_exists( 'TGM_Plugin_Activation' ) || ! isset( $GLOBALS['tgmpa'] ) ) {
			die( 'Failed to find TGM' );
		}
		$url = wp_nonce_url( add_query_arg( array( 'plugins' => 'go' ) ), 'whizzie-setup' );

		// copied from TGM
		$method = ''; // Leave blank so WP_Filesystem can populate it as necessary.
		$fields = array_keys( $_POST ); // Extra fields to pass to WP_Filesystem.
		if ( false === ( $creds = request_filesystem_credentials( esc_url_raw( $url ), $method, false, false, $fields ) ) ) {
			return true; // Stop the normal page form from displaying, credential request form will be shown.
		}
		// Now we have some credentials, setup WP_Filesystem.
		if ( ! WP_Filesystem( $creds ) ) {
			// Our credentials were no good, ask the user for them again.
			request_filesystem_credentials( esc_url_raw( $url ), $method, true, false, $fields );
			return true;
		}

		/* If we arrive here, we have the filesystem */ ?>
		<div class="wrap">
			<?php echo '<div class="whizzie-wrap">';
				// The wizard is a list with only one item visible at a time
				$steps = $this->get_steps();
				echo '<ul class="whizzie-nav wizard-icon-nav">';?>

				<?php
					$stepI=1;
					foreach( $steps as $step ) {
						$stepAct=($stepI ==1)? 1 : 0;
						if( isset( $step['icon_text'] ) && $step['icon_text'] ) {
							echo '<li class="commom-cls nav-step-' . esc_attr( $step['id'] ) . '" wizard-steps="step-'.esc_attr( $step['id'] ).'" data-enable="'.$stepAct.'">
							<p>'.esc_attr( $step['icon_text'] ).'</p>
							</li>';
						}
					$stepI++;}
			 	echo '</ul>';
				echo '<ul class="whizzie-menu wizard-menu-page">';
				foreach( $steps as $step ) {
					$class = 'step step-' . esc_attr( $step['id'] );
					echo '<li data-step="' . esc_attr( $step['id'] ) . '" class="' . esc_attr( $class ) . '" >';

						$content = call_user_func( array( $this, $step['view'] ) );
						if( isset( $content['summary'] ) ) {
							printf(
								'<div class="summary">%s</div>',
								wp_kses_post( $content['summary'] )
							);
						}
						if( isset( $content['detail'] ) ) {
							// Add a link to see more detail
							printf( '<div class="wz-require-plugins">');
							printf(
								'<div class="detail">%s</div>',
								$content['detail'] // Need to escape this
							);
							printf('</div>');
						}
						printf('<div class="wizard-button-wrapper">');
							// The next button
							if( isset( $step['button_text'] ) && $step['button_text'] ) {
								printf(
									'<div class="button-wrap"><a href="#" class="button button-primary do-it" data-callback="%s" data-step="%s">%s</a></div>',
									esc_attr( $step['callback'] ),
									esc_attr( $step['id'] ),
									esc_html( $step['button_text'] )
								);
							}

							if( isset( $step['button_text_one'] )) {
								printf(
									'<div class="button-wrap button-wrap-one">
										<a href="#" class="button button-primary do-it" data-callback="install_widgets" data-step="widgets"><p class="demo-type-text">%s</p></a>
									</div>',
									esc_html( $step['button_text_one'] )
								);
							}
						printf('</div>');
					echo '</li>';
				}
				echo '</ul>';
				?>
				<div class="step-loading"><span class="spinner">
					<img src="<?php echo esc_url(get_template_directory_uri().'/demo-import/assets/images/Spinner-Animaion.gif'); ?>">
				</span></div>
			<?php echo '</div>';?>
		</div>
	<?php }

	/**
	 * Set options for the steps
	 * @return Array
	*/

	public function get_steps() {

		if ( get_option('massage_wellness_retreat_demo_imported') ) {
			return array(
				'done' => array(
					'id'        => 'done',
					'title'     => __( 'All Done', 'massage-wellness-retreat' ),
					'icon'      => 'yes',
					'view'      => 'get_step_done',
					'callback'  => '',
					'icon_text' => 'View Site'
				)
			);
		}

		$dev_steps = $this->config_steps;

		$steps = array(
			'plugins' => array(
				'id'            => 'plugins',
				'title'         => __( 'Plugins', 'massage-wellness-retreat' ),
				'icon'          => 'admin-plugins',
				'view'          => 'get_step_plugins',
				'callback'      => 'install_plugins',
				'button_text'   => __( 'Install Plugins', 'massage-wellness-retreat' ),
				'can_skip'      => true,
				'icon_text'     => 'Plugins'
			),
			'widgets' => array(
				'id'            => 'widgets',
				'title'         => __( 'Customizer', 'massage-wellness-retreat' ),
				'icon'          => 'welcome-widgets-menus',
				'view'          => 'get_step_widgets',
				'callback'      => 'install_widgets',
				'button_text_one' => __( 'Import Demo', 'massage-wellness-retreat' ),
				'can_skip'      => true,
				'icon_text'     => 'Import Demo'
			),
			'done' => array(
				'id'            => 'done',
				'title'         => __( 'All Done', 'massage-wellness-retreat' ),
				'icon'          => 'yes',
				'view'          => 'get_step_done',
				'callback'      => '',
				'icon_text'     => 'Done'
			)
		);

		// config override
		if( $dev_steps ) {
			$can_config = array( 'title', 'icon', 'button_text', 'can_skip' );
			foreach( $dev_steps as $dev_step ) {
				if( isset( $dev_step['id'] ) ) {
					$id = $dev_step['id'];
					if( isset( $steps[$id] ) ) {
						foreach( $can_config as $element ) {
							if( isset( $dev_step[$element] ) ) {
								$steps[$id][$element] = $dev_step[$element];
							}
						}
					}
				}
			}
		}

		return $steps;
	}

	/*** Print the content for the intro step ***/
		public function get_step_importer() { ?>
		<div class="summary">
			<p>
				<?php esc_html_e('Thank you for choosing this Massage Wellness Retreat Theme. Using this quick setup wizard, you will be able to configure your new website and get it running in just a few minutes. Just follow these simple steps mentioned in the wizard and get started with your website.','massage-wellness-retreat'); ?>
			</p>
		</div>
	<?php }

	/**
	 * Get the content for the plugins step
	 * @return $content Array
	*/
	public function get_step_plugins() {
		$plugins = $this->get_plugins();
		$content = array(); ?>
			<div class="summary">
				<p>
					<?php esc_html_e('Install Recommended Plugins:	','massage-wellness-retreat') ?>
				</p>
			</div>
		<?php // The detail element is initially hidden from the user
		$content['detail'] = '<span class="wizard-plugin-count">Required Plugins: ' . count($plugins['all']) . '</span><ul class="whizzie-do-plugins">';
		// Add each plugin into a list
		foreach( $plugins['all'] as $slug=>$plugin ) {
			$content['detail'] .= '<li data-slug="' . esc_attr( $slug ) . '">' . esc_html( $plugin['name'] ) . '<div class="wizard-plugin-title">';

			$content['detail'] .= '<span class="wizard-plugin-status">Installation Required</span><i class="spinner"></i></div></li>';
		}
		$content['detail'] .= '</ul>';

		return $content;
	}

	/**    Print the content for the intro step     **/
	public function get_step_widgets() { ?>
		<div class="summary">
			<p>
				<?php esc_html_e('This theme allows you to import demo content and add widgets. Install them using the button below. You can also update or deactivate them using the Customizer.','massage-wellness-retreat'); ?>
			</p>
		</div>
	<?php }

	/***  Print the content for the final step  ***/
	public function get_step_done() { ?>

		<div class="setup-finish">
			<p>
				<?php echo esc_html('Your demo content has been imported successfully. Click the finish button for more information.'); ?>
			</p>
			<div class="finish-buttons">
				<a href="<?php echo esc_url( admin_url( 'themes.php?page=massage-wellness-retreat-getstart-page' ) ); ?>" class="wz-btn-customizer" target="_blank"><?php esc_html_e('About Massage Wellness Retreat','massage-wellness-retreat') ?></a>
				<a href="<?php echo esc_url(admin_url('/customize.php')); ?>" class="wz-btn-customizer" target="_blank"><?php esc_html_e('Customize Your Demo','massage-wellness-retreat') ?></a>
				<a href="<?php echo esc_url(home_url()); ?>" class="wz-btn-visit-site" target="_blank"><?php esc_html_e('Visit Your Site','massage-wellness-retreat'); ?></a>
			</div>
			<div class="finish-buttons">
				<a href="<?php echo esc_url(admin_url()); ?>" class="button button-primary"><?php esc_html_e('Finish','massage-wellness-retreat'); ?></a>
			</div>
		</div>

	<?php }

	/***  Get the plugins registered with TGMPA  ***/
	public function get_plugins() {
		$instance = call_user_func( array( get_class( $GLOBALS['tgmpa'] ), 'get_instance' ) );
		$plugins = array(
			'all' 		=> array(),
			'install'	=> array(),
			'update'	=> array(),
			'activate'	=> array()
		);
		foreach( $instance->plugins as $slug=>$plugin ) {
			if( $instance->is_plugin_active( $slug ) && false === $instance->does_plugin_have_update( $slug ) ) {
				// Plugin is installed and up to date
				continue;
			} else {
				$plugins['all'][$slug] = $plugin;
				if( ! $instance->is_plugin_installed( $slug ) ) {
					$plugins['install'][$slug] = $plugin;
				} else {
					if( false !== $instance->does_plugin_have_update( $slug ) ) {
						$plugins['update'][$slug] = $plugin;
					}
					if( $instance->can_plugin_activate( $slug ) ) {
						$plugins['activate'][$slug] = $plugin;
					}
				}
			}
		}
		return $plugins;
	}

	public function setup_plugins() {
		if ( ! check_ajax_referer( 'whizzie_nonce', 'wpnonce' ) || empty( $_POST['slug'] ) ) {
			wp_send_json_error( array( 'error' => 1, 'message' => esc_html__( 'No Slug Found','massage-wellness-retreat' ) ) );
		}
		$json = array();
		// send back some json we use to hit up TGM
		$plugins = $this->get_plugins();

		// what are we doing with this plugin?
		foreach ( $plugins['activate'] as $slug => $plugin ) {
			if ( $_POST['slug'] == $slug ) {
				$json = array(
					'url'           => admin_url( $this->tgmpa_url ),
					'plugin'        => array( $slug ),
					'tgmpa-page'    => $this->tgmpa_menu_slug,
					'plugin_status' => 'all',
					'_wpnonce'      => wp_create_nonce( 'bulk-plugins' ),
					'action'        => 'tgmpa-bulk-activate',
					'action2'       => - 1,
					'message'       => esc_html__( 'Activating Plugin','massage-wellness-retreat' ),
				);
				break;
			}
		}
		foreach ( $plugins['update'] as $slug => $plugin ) {
			if ( $_POST['slug'] == $slug ) {
				$json = array(
					'url'           => admin_url( $this->tgmpa_url ),
					'plugin'        => array( $slug ),
					'tgmpa-page'    => $this->tgmpa_menu_slug,
					'plugin_status' => 'all',
					'_wpnonce'      => wp_create_nonce( 'bulk-plugins' ),
					'action'        => 'tgmpa-bulk-update',
					'action2'       => - 1,
					'message'       => esc_html__( 'Updating Plugin','massage-wellness-retreat' ),
				);
				break;
			}
		}
		foreach ( $plugins['install'] as $slug => $plugin ) {
			if ( $_POST['slug'] == $slug ) {
				$json = array(
					'url'           => admin_url( $this->tgmpa_url ),
					'plugin'        => array( $slug ),
					'tgmpa-page'    => $this->tgmpa_menu_slug,
					'plugin_status' => 'all',
					'_wpnonce'      => wp_create_nonce( 'bulk-plugins' ),
					'action'        => 'tgmpa-bulk-install',
					'action2'       => - 1,
					'message'       => esc_html__( 'Installing Plugin','massage-wellness-retreat' ),
				);
				break;
			}
		}
		if ( $json ) {
			$json['hash'] = md5( serialize( $json ) ); // used for checking if duplicates happen, move to next plugin
			wp_send_json( $json );
		} else {
			wp_send_json( array( 'done' => 1, 'message' => esc_html__( 'Success','massage-wellness-retreat' ) ) );
		}
		exit;
	}

	//................................................. MENUS .................................................//
	
	public function massage_wellness_retreat_customizer_nav_menu() {
		// ------- Create Primary Menu --------
		$massage_wellness_retreat_themename = 'Massage Wellness Retreat'; // Ensure the theme name is set
		$massage_wellness_retreat_menuname = $massage_wellness_retreat_themename . ' Primary Menu';
		$massage_wellness_retreat_menulocation = 'menu-1';
		$massage_wellness_retreat_menu_exists = wp_get_nav_menu_object($massage_wellness_retreat_menuname);

		if (!$massage_wellness_retreat_menu_exists) {
			$massage_wellness_retreat_menu_id = wp_create_nav_menu($massage_wellness_retreat_menuname);

			// Home
			wp_update_nav_menu_item($massage_wellness_retreat_menu_id, 0, array(
				'menu-item-title' => __('Home', 'massage-wellness-retreat'),
				'menu-item-classes' => 'home',
				'menu-item-url' => home_url('/'),
				'menu-item-status' => 'publish'
			));

			// About
			$massage_wellness_retreat_page_about = get_page_by_path('about');
			if($massage_wellness_retreat_page_about){
				wp_update_nav_menu_item($massage_wellness_retreat_menu_id, 0, array(
					'menu-item-title' => __('About', 'massage-wellness-retreat'),
					'menu-item-classes' => 'about',
					'menu-item-url' => get_permalink($massage_wellness_retreat_page_about),
					'menu-item-status' => 'publish'
				));
			}

			// Services
			$massage_wellness_retreat_page_services = get_page_by_path('services');
			if($massage_wellness_retreat_page_services){
				wp_update_nav_menu_item($massage_wellness_retreat_menu_id, 0, array(
					'menu-item-title' => __('Services', 'massage-wellness-retreat'),
					'menu-item-classes' => 'services',
					'menu-item-url' => get_permalink($massage_wellness_retreat_page_services),
					'menu-item-status' => 'publish'
				));
			}

			// Blog
			$massage_wellness_retreat_page_blog = get_page_by_path('blog');
			if($massage_wellness_retreat_page_blog){
				wp_update_nav_menu_item($massage_wellness_retreat_menu_id, 0, array(
					'menu-item-title' => __('Blog', 'massage-wellness-retreat'),
					'menu-item-classes' => 'blog',
					'menu-item-url' => get_permalink($massage_wellness_retreat_page_blog),
					'menu-item-status' => 'publish'
				));
			}

			// Contact Us
			$massage_wellness_retreat_page_contact = get_page_by_path('contact');
			if($massage_wellness_retreat_page_contact){
				wp_update_nav_menu_item($massage_wellness_retreat_menu_id, 0, array(
					'menu-item-title' => __('Contact Us', 'massage-wellness-retreat'),
					'menu-item-classes' => 'contact',
					'menu-item-url' => get_permalink($massage_wellness_retreat_page_contact),
					'menu-item-status' => 'publish'
				));
			}

			// Assign menu to location if not set
			if (!has_nav_menu($massage_wellness_retreat_menulocation)) {
				$massage_wellness_retreat_locations = get_theme_mod('nav_menu_locations');
				$massage_wellness_retreat_locations[$massage_wellness_retreat_menulocation] = $massage_wellness_retreat_menu_id; // Use $massage_wellness_retreat_menu_id here
				set_theme_mod('nav_menu_locations', $massage_wellness_retreat_locations);
			}
		}
	}

	public function massage_wellness_retreat_social_menu() {

		// ------- Create Social Menu --------
		$massage_wellness_retreat_menuname = $massage_wellness_retreat_themename . 'Social Menu';
		$massage_wellness_retreat_menulocation = 'social-menu';
		$massage_wellness_retreat_menu_exists = wp_get_nav_menu_object( $massage_wellness_retreat_menuname );

		if( !$massage_wellness_retreat_menu_exists){
			$massage_wellness_retreat_menu_id = wp_create_nav_menu($massage_wellness_retreat_menuname);

			wp_update_nav_menu_item( $massage_wellness_retreat_menu_id, 0, array(
				'menu-item-title'  => __( 'Facebook', 'massage-wellness-retreat' ),
				'menu-item-url'    => 'https://www.facebook.com',
				'menu-item-status' => 'publish',
			) );

			wp_update_nav_menu_item( $massage_wellness_retreat_menu_id, 0, array(
				'menu-item-title'  => __( 'Pinterest', 'massage-wellness-retreat' ),
				'menu-item-url'    => 'https://www.pinterest.com',
				'menu-item-status' => 'publish',
			) );
	
			wp_update_nav_menu_item( $massage_wellness_retreat_menu_id, 0, array(
				'menu-item-title'  => __( 'Twitter', 'massage-wellness-retreat' ),
				'menu-item-url'    => 'https://www.twitter.com',
				'menu-item-status' => 'publish',
			) );
	
			wp_update_nav_menu_item( $massage_wellness_retreat_menu_id, 0, array(
				'menu-item-title'  => __( 'Youtube', 'massage-wellness-retreat' ),
				'menu-item-url'    => 'https://www.youtube.com',
				'menu-item-status' => 'publish',
			) );

			wp_update_nav_menu_item( $massage_wellness_retreat_menu_id, 0, array(
				'menu-item-title'  => __( 'Instagram', 'massage-wellness-retreat' ),
				'menu-item-url'    => 'https://www.instagram.com',
				'menu-item-status' => 'publish',
			) );

			if( !has_nav_menu( $massage_wellness_retreat_menulocation ) ){
					$locations = get_theme_mod('nav_menu_locations');
					$locations[$massage_wellness_retreat_menulocation] = $massage_wellness_retreat_menu_id;
					set_theme_mod( 'nav_menu_locations', $locations );
			}
		}
	}

	/**
	* Imports the Demo Content
	* @since 1.1.0
	*/
	public function setup_widgets() {

		//................................................. MENU PAGES .................................................//
		
		$massage_wellness_retreat_home_id='';
		$massage_wellness_retreat_home_content = '';

		$massage_wellness_retreat_home_title = 'Home';
		$massage_wellness_retreat_home = array(
				'post_type' => 'page',
				'post_title' => $massage_wellness_retreat_home_title,
				'post_content'  => $massage_wellness_retreat_home_content,
				'post_status' => 'publish',
				'post_author' => 1,
				'post_slug' => 'home'
		);
		$massage_wellness_retreat_home_id = wp_insert_post($massage_wellness_retreat_home);

		//Set the home page template
		add_post_meta( $massage_wellness_retreat_home_id, '_wp_page_template', 'revolution-home.php' );

		//Set the static front page
		$massage_wellness_retreat_home = get_page_by_title( 'Home' );
		update_option( 'page_on_front', $massage_wellness_retreat_home->ID );
		update_option( 'show_on_front', 'page' );


		// Create a posts page and assign the template
		$massage_wellness_retreat_blog_title = 'Blog';
		$massage_wellness_retreat_blog_check = get_page_by_path('blog');
		if (!$massage_wellness_retreat_blog_check) {
			$massage_wellness_retreat_blog = array(
				'post_type'    => 'page',
				'post_title'   => $massage_wellness_retreat_blog_title,
				'post_status'  => 'publish',
				'post_author'  => 1,
				'post_name'    => 'blog' // Unique slug for the blog page
			);
			$massage_wellness_retreat_blog_id = wp_insert_post($massage_wellness_retreat_blog);

			// Set the posts page
			if (!is_wp_error($massage_wellness_retreat_blog_id)) {
				update_option('page_for_posts', $massage_wellness_retreat_blog_id);
			}
		}

		// Create a Contact Us page and assign the template
		$massage_wellness_retreat_contact_title = 'Contact Us';
		$massage_wellness_retreat_contact_check = get_page_by_path('contact');
		if (!$massage_wellness_retreat_contact_check) {
			$massage_wellness_retreat_contact = array(
				'post_type'    => 'page',
				'post_title'   => $massage_wellness_retreat_contact_title,
				'post_content'   => '"More About The Free Wellness WordPress Theme"
										The Free Wellness WordPress Theme offers a refined, multipurpose design tailored specifically for the wellness and spa industry. With a clean, minimal, and sophisticated interface, it ensures visitors enjoy a clutter-free browsing experience. Its retina-ready visuals and responsive design contribute to a user-friendly environment that looks beautiful across all screen sizes. Whether you\'re creating a Massage Wellness Retreat or a holistic therapy portal, this theme instantly sets the tone with elegant simplicity. It’s designed for both beginners and developers, offering intuitive controls and customizability without compromising performance. The theme embodies a calm, modern aesthetic, perfect for promoting wellness services with clarity and elegance.

										What makes this theme truly powerful are the built-in features tailored to wellness professionals. With sections like team bios, testimonial displays, and engaging banners, it adds both trust and personality to your website. The strategic placement of CTA buttons throughout the site encourages visitors to schedule sessions, reach out, or sign up for offers. The social media integration boosts online presence, while translation-ready capabilities help you reach international clients. Developers will appreciate its secure and clean code base, while agencies can rely on its scalability and performance. With Bootstrap at its core and optimized load times, this theme is built to grow with your business.

										This theme stands out with its powerful customization options, including shortcodes and layout controls, which allow you to build a unique site without needing to code from scratch. Whether you want to highlight services, display packages, or promote limited-time offers, the flexibility is unmatched. The lightweight, optimized code ensures your website loads quickly, enhancing SEO and user retention. Its animated effects add a touch of interactivity, making your Free Wellness WordPress Theme more engaging and professional. Developers can work with confidence, thanks to the secure structure and well-documented code. Whether you\'re a freelancer, business owner, or agency, this free theme is a luxurious start to building a modern wellness brand.',
					'post_status'  => 'publish',
				'post_author'  => 1,
				'post_name'    => 'contact' // Unique slug for the Contact Us page
			);
			wp_insert_post($massage_wellness_retreat_contact);
		}

		// Create a About page and assign the template
		$massage_wellness_retreat_about_title = 'About';
		$massage_wellness_retreat_about_check = get_page_by_path('about');
		if (!$massage_wellness_retreat_about_check) {
			$massage_wellness_retreat_about = array(
				'post_type'    => 'page',
				'post_title'   => $massage_wellness_retreat_about_title,
				'post_content'   => '"More About The Free Wellness WordPress Theme"
										The Free Wellness WordPress Theme offers a refined, multipurpose design tailored specifically for the wellness and spa industry. With a clean, minimal, and sophisticated interface, it ensures visitors enjoy a clutter-free browsing experience. Its retina-ready visuals and responsive design contribute to a user-friendly environment that looks beautiful across all screen sizes. Whether you\'re creating a Massage Wellness Retreat or a holistic therapy portal, this theme instantly sets the tone with elegant simplicity. It’s designed for both beginners and developers, offering intuitive controls and customizability without compromising performance. The theme embodies a calm, modern aesthetic, perfect for promoting wellness services with clarity and elegance.

										What makes this theme truly powerful are the built-in features tailored to wellness professionals. With sections like team bios, testimonial displays, and engaging banners, it adds both trust and personality to your website. The strategic placement of CTA buttons throughout the site encourages visitors to schedule sessions, reach out, or sign up for offers. The social media integration boosts online presence, while translation-ready capabilities help you reach international clients. Developers will appreciate its secure and clean code base, while agencies can rely on its scalability and performance. With Bootstrap at its core and optimized load times, this theme is built to grow with your business.

										This theme stands out with its powerful customization options, including shortcodes and layout controls, which allow you to build a unique site without needing to code from scratch. Whether you want to highlight services, display packages, or promote limited-time offers, the flexibility is unmatched. The lightweight, optimized code ensures your website loads quickly, enhancing SEO and user retention. Its animated effects add a touch of interactivity, making your Free Wellness WordPress Theme more engaging and professional. Developers can work with confidence, thanks to the secure structure and well-documented code. Whether you\'re a freelancer, business owner, or agency, this free theme is a luxurious start to building a modern wellness brand.',
					'post_status'  => 'publish',
				'post_author'  => 1,
				'post_name'    => 'about' // Unique slug for the About page
			);
			wp_insert_post($massage_wellness_retreat_about);
		}

		// Create a Services page and assign the template
		$massage_wellness_retreat_services_title = 'Services';
		$massage_wellness_retreat_services_check = get_page_by_path('services');
		if (!$massage_wellness_retreat_services_check) {
			$massage_wellness_retreat_services = array(
				'post_type'    => 'page',
				'post_title'   => $massage_wellness_retreat_services_title,
				'post_content'   => '"More About The Free Wellness WordPress Theme"
										The Free Wellness WordPress Theme offers a refined, multipurpose design tailored specifically for the wellness and spa industry. With a clean, minimal, and sophisticated interface, it ensures visitors enjoy a clutter-free browsing experience. Its retina-ready visuals and responsive design contribute to a user-friendly environment that looks beautiful across all screen sizes. Whether you\'re creating a Massage Wellness Retreat or a holistic therapy portal, this theme instantly sets the tone with elegant simplicity. It’s designed for both beginners and developers, offering intuitive controls and customizability without compromising performance. The theme embodies a calm, modern aesthetic, perfect for promoting wellness services with clarity and elegance.

										What makes this theme truly powerful are the built-in features tailored to wellness professionals. With sections like team bios, testimonial displays, and engaging banners, it adds both trust and personality to your website. The strategic placement of CTA buttons throughout the site encourages visitors to schedule sessions, reach out, or sign up for offers. The social media integration boosts online presence, while translation-ready capabilities help you reach international clients. Developers will appreciate its secure and clean code base, while agencies can rely on its scalability and performance. With Bootstrap at its core and optimized load times, this theme is built to grow with your business.

										This theme stands out with its powerful customization options, including shortcodes and layout controls, which allow you to build a unique site without needing to code from scratch. Whether you want to highlight services, display packages, or promote limited-time offers, the flexibility is unmatched. The lightweight, optimized code ensures your website loads quickly, enhancing SEO and user retention. Its animated effects add a touch of interactivity, making your Free Wellness WordPress Theme more engaging and professional. Developers can work with confidence, thanks to the secure structure and well-documented code. Whether you\'re a freelancer, business owner, or agency, this free theme is a luxurious start to building a modern wellness brand.',
					'post_status'  => 'publish',
				'post_author'  => 1,
				'post_name'    => 'services' // Unique slug for the Services page
			);
			wp_insert_post($massage_wellness_retreat_services);
		}


		// ------------------------------------------ Sections -------------------------------------- //

			set_theme_mod('massage_wellness_retreat_enable_event',1);
			set_theme_mod('massage_wellness_retreat_show_slider',1);
			

		// ------------------------------------------ Slider Section -------------------------------------- //

			for($massage_wellness_retreat_i=1;$massage_wellness_retreat_i<=3;$massage_wellness_retreat_i++){
				set_theme_mod( 'massage_wellness_retreat_banner_background_image_sec'.$massage_wellness_retreat_i,get_template_directory_uri().'/revolution/assets/images/slider'.$massage_wellness_retreat_i.'.png' );
				set_theme_mod( 'massage_wellness_retreat_slider_top_title'.$massage_wellness_retreat_i, 'TranquilNest Spa' );
				set_theme_mod( 'massage_wellness_retreat_slider_title'.$massage_wellness_retreat_i, 'Relax, Refresh, Rejuvenate With Us.' );
				set_theme_mod( 'massage_wellness_retreat_slider_text'.$massage_wellness_retreat_i, 'Experience ultimate relaxation at our massage center, where skilled hands melt away stress. Rejuvenate your body and mind in a serene environment designed for your comfort, healing, and well-being.' );
				set_theme_mod( 'massage_wellness_retreat_slider_button1_text'.$massage_wellness_retreat_i, 'Explore more' );
				set_theme_mod( 'massage_wellness_retreat_slider_button1_link'.$massage_wellness_retreat_i, '#' );
			}


		// ------------------------------------------ Second Section -------------------------------------- //

			set_theme_mod( 'massage_wellness_retreat_section_short_title', 'What We Do?' );

			wp_delete_post(1);
			$blog_title = array(
				'Swedish Massage',
				'Deep Tissue Massage',
				'Aromatherapy Massage',
				'Hot Stone Massage',
			);

			for($i=1;$i<=4;$i++){
				$title = $blog_title[$i-1];
				$content = 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis lacus libero, ultrices at sagittis a, vehicula sed sapien..';
			
				$my_post = array(
					'post_title'    => wp_strip_all_tags( $title ),
					'post_content'  => $content,
					'post_status'   => 'publish',
					'post_type'     => 'post',
				);
			
				$post_id = wp_insert_post( $my_post );
			
				wp_set_object_terms($post_id, 'Slider', 'category', true);

				wp_set_object_terms($post_id, 'Slider', 'post_tag', true);
			
				$image_url = get_template_directory_uri().'/revolution/assets/images/blogs'.$i.'.png';
				$image_name= 'blogs'.$i.'.png';
				$upload_dir = wp_upload_dir();
				$image_data = file_get_contents($image_url);
				$unique_file_name = wp_unique_filename( $upload_dir['path'], $image_name );
				$filename = basename( $unique_file_name );
			
				if( wp_mkdir_p( $upload_dir['path'] ) ) {
					$file = $upload_dir['path'] . '/' . $filename;
				} else {
					$file = $upload_dir['basedir'] . '/' . $filename;
				}
			
				if ( ! function_exists( 'WP_Filesystem' ) ) {
					require_once( ABSPATH . 'wp-admin/includes/file.php' );
				}
				WP_Filesystem();
				global $wp_filesystem;
			
				if ( ! $wp_filesystem->put_contents( $file, $image_data, FS_CHMOD_FILE ) ) {
					wp_die( 'Error saving file!' );
				}
			
				$wp_filetype = wp_check_filetype( $filename, null );
				$attachment = array(
					'post_mime_type' => $wp_filetype['type'],
					'post_title'     => sanitize_file_name( $filename ),
					'post_content'   => '',
					'post_type'      => 'post',
					'post_status'    => 'inherit'
				);
			
				$attach_id = wp_insert_attachment( $attachment, $file, $post_id );
			
				require_once(ABSPATH . 'wp-admin/includes/image.php');
			
				$attach_data = wp_generate_attachment_metadata( $attach_id, $file );
				wp_update_attachment_metadata( $attach_id, $attach_data );
				set_post_thumbnail( $post_id, $attach_id );
			}


			$wellness_therapy_slider_title = 'Service 1';
			$wellness_therapy_slider_content = 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse vitae ligula placerat, eleifend ex,Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse vitae ligula placerat, eleifend ex,Lorem ipsum dolor sit amet, consectetur adipiscing elit. Suspendisse vitae ligula placerat, eleifend ex';
			$wellness_therapy_slider_check = get_page_by_path('service-page');

			// Check if the page already exists, if not, create the page
			if (!$wellness_therapy_slider_check) {
				// Insert the page
				$wellness_therapy_slider = array(
					'post_type'   => 'page',
					'post_title'  => $wellness_therapy_slider_title,
					'post_content'  => $wellness_therapy_slider_content,
					'post_status' => 'publish',
					'post_author' => 1,
					'post_name'   => 'service-page'
				);
				
				// Insert the post (page)
				$page_id = wp_insert_post($wellness_therapy_slider);
				
				// Get the image URL (replace 'about-img.png' with the actual path to the image)
				$image_path = get_template_directory() . '/revolution/assets/images/about-img.png';  // Path to your image in theme folder
				
				// If the image exists, upload it to the media library and set it as the featured image
				if (file_exists($image_path)) {
					// Upload the image
					$upload = wp_upload_bits('about-img.png', null, file_get_contents($image_path));
					
					// Check if the upload was successful
					if (!$upload['error']) {
						// Create an attachment post
						$attachment = array(
							'guid' => $upload['url'], 
							'post_mime_type' => 'image/png',
							'post_title' => basename($image_path),
							'post_content' => '',
							'post_status' => 'inherit'
						);
						
						// Insert the attachment into the media library
						$attachment_id = wp_insert_attachment($attachment, $upload['file'], $page_id);
						
						// Generate the metadata for the attachment
						$attachment_data = wp_generate_attachment_metadata($attachment_id, $upload['file']);
						wp_update_attachment_metadata($attachment_id, $attachment_data);
						
						// Set the image as the featured image for the page
						set_post_thumbnail($page_id, $attachment_id);
					}
				}
			}

			set_theme_mod( 'wellness_therapy_section_heading_text', 'Our Services?' );

			$tab_title=array('Swedish Massage','Deep Tissue Massage','Hot Stone Massage','Armotherapy Massage','Thai Massage','Physiotherapy');
			$services_icon=array('fas fa-spa','fas fa-spa','fas fa-spa','fas fa-spa','fas fa-spa','fas fa-spa');
			for($i=1;$i<=6;$i++) {
				set_theme_mod( 'wellness_therapy_services_icon'.$i, $services_icon[$i-1] );
				set_theme_mod( 'wellness_therapy_projetcs_text'.$i, $tab_title[$i-1] );
				// set_theme_mod( 'wellness_therapy_about_page'.$i, get_page_by_path('service-page'));
			}


  	 	$this->massage_wellness_retreat_customizer_nav_menu();
  	 	$this->massage_wellness_retreat_social_menu();
		update_option('massage_wellness_retreat_demo_imported', true);
	}

	public function massage_wellness_retreat_guide() {
		$display_string = '';
		$return = add_query_arg( array()) ;
		$theme = wp_get_theme( 'massage-wellness-retreat' );
		?>
		<div class="wrapper-info get-stared-page-wrap">
			<div class="wrapper-info-content">
				<div class="buynow__">
					<h2><?php esc_html_e( 'Welcome to Massage Wellness Retreat', 'massage-wellness-retreat' ); ?> <span class="version">Version: <?php echo esc_html($theme['Version']);?></span></h2>
					<p><?php esc_html_e('The quick setup wizard will assist you in configuring your new website. This wizard will import the demo content.', 'massage-wellness-retreat'); ?></p>
				</div>
				<div class="buynow_">
					<a target="_blank" class="buynow_themepage" href="<?php echo esc_url('https://www.revolutionwp.com/products/massage-wordpress-theme'); ?>"><?php echo esc_html__('Go Premium Now', 'massage-wellness-retreat'); ?></a>
				</div>
			</div>
			<div class="tab-sec theme-option-tab">
				<div id="demo_offer" class="tabcontent open">
					<?php $this->wizard_page(); ?>
				</div>
			</div>
		</div>
	<?php }
}